Linux polon 4.19.0-27-amd64 #1 SMP Debian 4.19.316-1 (2024-06-25) x86_64
Apache/2.4.59 (Debian)
: 10.2.73.233 | : 216.73.216.105
Cant Read [ /etc/named.conf ]
5.6.40-64+0~20230107.71+debian10~1.gbp673146
ifk
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
HASH IDENTIFIER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
X11
[ DIR ]
drwxr-xr-x
2to3-2.7
96
B
-rwxr-xr-x
GET
15.82
KB
-rwxr-xr-x
HEAD
15.82
KB
-rwxr-xr-x
Mail
110.24
KB
-rwxr-xr-x
POST
15.82
KB
-rwxr-xr-x
[
58.66
KB
-rwxr-xr-x
aa-enabled
30.21
KB
-rwxr-xr-x
aa-exec
30.21
KB
-rwxr-xr-x
ab
54.18
KB
-rwxr-xr-x
aclocal
35.62
KB
-rwxr-xr-x
aclocal-1.16
35.62
KB
-rwxr-xr-x
acpi
23.43
KB
-rwxr-xr-x
acpi_listen
14.27
KB
-rwxr-xr-x
add-apt-repository
6.21
KB
-rwxr-xr-x
addpart
26.08
KB
-rwxr-xr-x
addr2line
31.09
KB
-rwxr-xr-x
appletviewer
6.34
KB
-rwxr-xr-x
appres
10.23
KB
-rwxr-xr-x
apropos
54.98
KB
-rwxr-xr-x
apt
18.09
KB
-rwxr-xr-x
apt-add-repository
6.21
KB
-rwxr-xr-x
apt-cache
82.16
KB
-rwxr-xr-x
apt-cdrom
26.16
KB
-rwxr-xr-x
apt-config
26.09
KB
-rwxr-xr-x
apt-extracttemplates
22.16
KB
-rwxr-xr-x
apt-ftparchive
238.16
KB
-rwxr-xr-x
apt-get
46.16
KB
-rwxr-xr-x
apt-key
27.08
KB
-rwxr-xr-x
apt-listchanges
10.61
KB
-rwxr-xr-x
apt-mark
54.16
KB
-rwxr-xr-x
apt-sortpkgs
46.09
KB
-rwxr-xr-x
aptitude
4.18
MB
-rwxr-xr-x
aptitude-create-state-bundle
1.89
KB
-rwxr-xr-x
aptitude-curses
4.18
MB
-rwxr-xr-x
aptitude-run-state-bundle
2.78
KB
-rwxr-xr-x
ar
63.07
KB
-rwxr-xr-x
arch
38.66
KB
-rwxr-xr-x
aria_chk
4.54
MB
-rwxr-xr-x
aria_dump_log
4.35
MB
-rwxr-xr-x
aria_ftdump
4.37
MB
-rwxr-xr-x
aria_pack
4.39
MB
-rwxr-xr-x
aria_read_log
4.5
MB
-rwxr-xr-x
as
872.93
KB
-rwxr-xr-x
aspell
150.34
KB
-rwxr-xr-x
aspell-import
2
KB
-rwxr-xr-x
at
54.26
KB
-rwsr-sr-x
atq
54.26
KB
-rwsr-sr-x
atrm
54.26
KB
-rwsr-sr-x
autoconf
14.42
KB
-rwxr-xr-x
autoheader
8.34
KB
-rwxr-xr-x
autom4te
31.91
KB
-rwxr-xr-x
automake
251.9
KB
-rwxr-xr-x
automake-1.16
251.9
KB
-rwxr-xr-x
autopoint
25.97
KB
-rwxr-xr-x
autoreconf
20.67
KB
-rwxr-xr-x
autoscan
16.73
KB
-rwxr-xr-x
autoupdate
33.08
KB
-rwxr-xr-x
awk
658.81
KB
-rwxr-xr-x
b2sum
58.78
KB
-rwxr-xr-x
base32
42.69
KB
-rwxr-xr-x
base64
42.69
KB
-rwxr-xr-x
basename
38.59
KB
-rwxr-xr-x
bashbug
6.63
KB
-rwxr-xr-x
batch
152
B
-rwxr-xr-x
bc
86.7
KB
-rwxr-xr-x
bootctl
46.23
KB
-rwxr-xr-x
broadwayd
118.08
KB
-rwxr-xr-x
bsd-from
10.24
KB
-rwxr-xr-x
bsd-mailx
110.24
KB
-rwxr-xr-x
bsd-write
14.39
KB
-rwxr-sr-x
buildhash
38.38
KB
-rwxr-xr-x
busctl
78.19
KB
-rwxr-xr-x
c++
1.05
MB
-rwxr-xr-x
c++filt
30.69
KB
-rwxr-xr-x
c89
428
B
-rwxr-xr-x
c89-gcc
428
B
-rwxr-xr-x
c99
454
B
-rwxr-xr-x
c99-gcc
454
B
-rwxr-xr-x
c_rehash
6.13
KB
-rwxr-xr-x
cal
29.15
KB
-rwxr-xr-x
calendar
31.15
KB
-rwxr-xr-x
captoinfo
86.11
KB
-rwxr-xr-x
catchsegv
3.23
KB
-rwxr-xr-x
catman
38.46
KB
-rwxr-xr-x
cc
1.05
MB
-rwxr-xr-x
cd-create-profile
21.99
KB
-rwxr-xr-x
cd-fix-profile
25.99
KB
-rwxr-xr-x
cd-iccdump
13.99
KB
-rwxr-xr-x
cd-it8
21.99
KB
-rwxr-xr-x
chacl
13.99
KB
-rwxr-xr-x
chage
70.13
KB
-rwxr-sr-x
chardet
389
B
-rwxr-xr-x
chardet3
389
B
-rwxr-xr-x
chardetect
389
B
-rwxr-xr-x
chardetect3
389
B
-rwxr-xr-x
chattr
14
KB
-rwxr-xr-x
chcon
62.91
KB
-rwxr-xr-x
checkgid
13.99
KB
-rwxr-xr-x
chfn
52.83
KB
-rwsr-xr-x
choom
50.08
KB
-rwxr-xr-x
chrt
34.08
KB
-rwxr-xr-x
chsh
43.48
KB
-rwsr-xr-x
ckbcomp
146.38
KB
-rwxr-xr-x
cksum
38.63
KB
-rwxr-xr-x
clear
14
KB
-rwxr-xr-x
clear_console
14.3
KB
-rwxr-xr-x
clhsdb
6.35
KB
-rwxr-xr-x
cmp
50.64
KB
-rwxr-xr-x
codepage
14.21
KB
-rwxr-xr-x
col
10.23
KB
-rwxr-xr-x
colcrt
10.2
KB
-rwxr-xr-x
colormgr
53.99
KB
-rwxr-xr-x
colrm
10.19
KB
-rwxr-xr-x
column
10.34
KB
-rwxr-xr-x
comm
42.69
KB
-rwxr-xr-x
compose
17.74
KB
-rwxr-xr-x
corelist
14.73
KB
-rwxr-xr-x
cpan
7.96
KB
-rwxr-xr-x
cpan5.28-x86_64-linux-gnu
7.99
KB
-rwxr-xr-x
cpio-filter
1.22
KB
-rwxr-xr-x
cpp
1.05
MB
-rwxr-xr-x
cpp-4.9
814.43
KB
-rwxr-xr-x
cpp-6
930.77
KB
-rwxr-xr-x
cpp-8
1.05
MB
-rwxr-xr-x
crc32
1.04
KB
-rwxr-xr-x
crontab
42.55
KB
-rwxr-sr-x
csplit
54.84
KB
-rwxr-xr-x
ctstat
22.74
KB
-rwxr-xr-x
curl
226.07
KB
-rwxr-xr-x
cut
42.75
KB
-rwxr-xr-x
cvtsudoers
250.29
KB
-rwxr-xr-x
dbilogstrip
1.35
KB
-rwxr-xr-x
dbiprof
6.06
KB
-rwxr-xr-x
dbiproxy
5.27
KB
-rwxr-xr-x
dbus-cleanup-sockets
13.98
KB
-rwxr-xr-x
dbus-daemon
235.04
KB
-rwxr-xr-x
dbus-monitor
25.99
KB
-rwxr-xr-x
dbus-run-session
13.98
KB
-rwxr-xr-x
dbus-send
29.98
KB
-rwxr-xr-x
dbus-update-activation-environ...
13.98
KB
-rwxr-xr-x
dbus-uuidgen
13.98
KB
-rwxr-xr-x
dc
46.09
KB
-rwxr-xr-x
deallocvt
14.31
KB
-rwxr-xr-x
deb-systemd-helper
20.83
KB
-rwxr-xr-x
deb-systemd-invoke
4.33
KB
-rwxr-xr-x
debconf
2.79
KB
-rwxr-xr-x
debconf-apt-progress
11.27
KB
-rwxr-xr-x
debconf-communicate
608
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
647
B
-rwxr-xr-x
debconf-gettextize
15.97
KB
-rwxr-xr-x
debconf-set-selections
2.87
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debconf-updatepo
4.46
KB
-rwxr-xr-x
debianbts
413
B
-rwxr-xr-x
defmt-c
5.99
KB
-rwxr-xr-x
defmt-sh
5.99
KB
-rwxr-xr-x
delpart
26.08
KB
-rwxr-xr-x
delv
44.83
KB
-rwxr-xr-x
dh
30.77
KB
-rwxr-xr-x
dh_auto_build
1.37
KB
-rwxr-xr-x
dh_auto_clean
1.51
KB
-rwxr-xr-x
dh_auto_configure
1.63
KB
-rwxr-xr-x
dh_auto_install
2.8
KB
-rwxr-xr-x
dh_auto_test
1.65
KB
-rwxr-xr-x
dh_autoreconf
6.46
KB
-rwxr-xr-x
dh_autoreconf_clean
2.1
KB
-rwxr-xr-x
dh_autotools-dev_restoreconfig
1.79
KB
-rwxr-xr-x
dh_autotools-dev_updateconfig
1.81
KB
-rwxr-xr-x
dh_bash-completion
2.39
KB
-rwxr-xr-x
dh_bugfiles
3.58
KB
-rwxr-xr-x
dh_builddeb
4.96
KB
-rwxr-xr-x
dh_clean
4.91
KB
-rwxr-xr-x
dh_compress
7.58
KB
-rwxr-xr-x
dh_dkms
4.2
KB
-rwxr-xr-x
dh_dwz
3.84
KB
-rwxr-xr-x
dh_fixperms
5.28
KB
-rwxr-xr-x
dh_gconf
2.78
KB
-rwxr-xr-x
dh_gencontrol
5.85
KB
-rwxr-xr-x
dh_icons
2.04
KB
-rwxr-xr-x
dh_install
11.24
KB
-rwxr-xr-x
dh_installcatalogs
3.25
KB
-rwxr-xr-x
dh_installchangelogs
9
KB
-rwxr-xr-x
dh_installcron
1.6
KB
-rwxr-xr-x
dh_installdeb
7.8
KB
-rwxr-xr-x
dh_installdebconf
3.21
KB
-rwxr-xr-x
dh_installdirs
3
KB
-rwxr-xr-x
dh_installdocs
14.67
KB
-rwxr-xr-x
dh_installemacsen
3.74
KB
-rwxr-xr-x
dh_installexamples
5.33
KB
-rwxr-xr-x
dh_installgsettings
2.24
KB
-rwxr-xr-x
dh_installifupdown
1.47
KB
-rwxr-xr-x
dh_installinfo
2.87
KB
-rwxr-xr-x
dh_installinit
14.31
KB
-rwxr-xr-x
dh_installinitramfs
2.18
KB
-rwxr-xr-x
dh_installlogcheck
1.94
KB
-rwxr-xr-x
dh_installlogrotate
1.14
KB
-rwxr-xr-x
dh_installman
11.07
KB
-rwxr-xr-x
dh_installmanpages
4.89
KB
-rwxr-xr-x
dh_installmenu
2.15
KB
-rwxr-xr-x
dh_installmime
1.3
KB
-rwxr-xr-x
dh_installmodules
2.63
KB
-rwxr-xr-x
dh_installpam
1.13
KB
-rwxr-xr-x
dh_installppp
1.38
KB
-rwxr-xr-x
dh_installsystemd
13.06
KB
-rwxr-xr-x
dh_installsystemduser
7.41
KB
-rwxr-xr-x
dh_installtex
17.95
KB
-rwxr-xr-x
dh_installudev
2.1
KB
-rwxr-xr-x
dh_installwm
3.25
KB
-rwxr-xr-x
dh_installxfonts
2.91
KB
-rwxr-xr-x
dh_link
4.24
KB
-rwxr-xr-x
dh_lintian
1.29
KB
-rwxr-xr-x
dh_listpackages
824
B
-rwxr-xr-x
dh_makeshlibs
10.87
KB
-rwxr-xr-x
dh_md5sums
3.4
KB
-rwxr-xr-x
dh_missing
6.32
KB
-rwxr-xr-x
dh_movefiles
4.69
KB
-rwxr-xr-x
dh_perl
4.23
KB
-rwxr-xr-x
dh_perl_dbi
1.04
KB
-rwxr-xr-x
dh_perl_openssl
1.36
KB
-rwxr-xr-x
dh_phpcomposer
3.01
KB
-rwxr-xr-x
dh_phppear
5.63
KB
-rwxr-xr-x
dh_prep
1.87
KB
-rwxr-xr-x
dh_pysupport
11.95
KB
-rwxr-xr-x
dh_python2
1.03
KB
-rwxr-xr-x
dh_shlibdeps
6.13
KB
-rwxr-xr-x
dh_strip
14.45
KB
-rwxr-xr-x
dh_strip_nondeterminism
2.68
KB
-rwxr-xr-x
dh_systemd_enable
8.97
KB
-rwxr-xr-x
dh_systemd_start
8.57
KB
-rwxr-xr-x
dh_testdir
1.3
KB
-rwxr-xr-x
dh_testroot
2.86
KB
-rwxr-xr-x
dh_ucf
2.29
KB
-rwxr-xr-x
dh_update_autotools_config
1.84
KB
-rwxr-xr-x
dh_usrlocal
4.2
KB
-rwxr-xr-x
diff
215.28
KB
-rwxr-xr-x
diff3
66.84
KB
-rwxr-xr-x
dig
146.51
KB
-rwxr-xr-x
dircolors
46.66
KB
-rwxr-xr-x
dirmngr
553.55
KB
-rwxr-xr-x
dirmngr-client
114.76
KB
-rwxr-xr-x
dirname
34.59
KB
-rwxr-xr-x
discover-config
2.86
KB
-rwxr-xr-x
dnstap-read
18.01
KB
-rwxr-xr-x
dos2unix
50.02
KB
-rwxr-xr-x
dotlockfile
18.5
KB
-rwxr-sr-x
dpkg
298.53
KB
-rwxr-xr-x
dpkg-architecture
12.55
KB
-rwxr-xr-x
dpkg-buildflags
7.39
KB
-rwxr-xr-x
dpkg-buildpackage
29.89
KB
-rwxr-xr-x
dpkg-checkbuilddeps
7.45
KB
-rwxr-xr-x
dpkg-deb
162.38
KB
-rwxr-xr-x
dpkg-distaddfile
2.72
KB
-rwxr-xr-x
dpkg-divert
150.44
KB
-rwxr-xr-x
dpkg-genbuildinfo
16.4
KB
-rwxr-xr-x
dpkg-genchanges
17.08
KB
-rwxr-xr-x
dpkg-gencontrol
13.82
KB
-rwxr-xr-x
dpkg-gensymbols
10.65
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.03
KB
-rwxr-xr-x
dpkg-mergechangelogs
8.35
KB
-rwxr-xr-x
dpkg-name
6.63
KB
-rwxr-xr-x
dpkg-parsechangelog
4.46
KB
-rwxr-xr-x
dpkg-query
158.43
KB
-rwxr-xr-x
dpkg-scanpackages
8.49
KB
-rwxr-xr-x
dpkg-scansources
8.95
KB
-rwxr-xr-x
dpkg-shlibdeps
30.68
KB
-rwxr-xr-x
dpkg-source
22.48
KB
-rwxr-xr-x
dpkg-split
122.34
KB
-rwxr-xr-x
dpkg-statoverride
62.12
KB
-rwxr-xr-x
dpkg-trigger
78.34
KB
-rwxr-xr-x
dpkg-vendor
3.19
KB
-rwxr-xr-x
du
107.09
KB
-rwxr-xr-x
dumpkeys
174.91
KB
-rwxr-xr-x
dvipdf
1023
B
-rwxr-xr-x
dwp
2.74
MB
-rwxr-xr-x
dwz
164.09
KB
-rwxr-xr-x
edit
17.74
KB
-rwxr-xr-x
editor
240.39
KB
-rwxr-xr-x
editres
69.38
KB
-rwxr-xr-x
eject
30.69
KB
-rwxr-xr-x
elfedit
38.84
KB
-rwxr-xr-x
enc2xs
41.12
KB
-rwxr-xr-x
encguess
2.99
KB
-rwxr-xr-x
enchant
22.07
KB
-rwxr-xr-x
enchant-lsmod
13.99
KB
-rwxr-xr-x
env
42.66
KB
-rwxr-xr-x
envsubst
42.64
KB
-rwxr-xr-x
eps2eps
639
B
-rwxr-xr-x
eqn
201.19
KB
-rwxr-xr-x
ex
2.58
MB
-rwxr-xr-x
expand
42.69
KB
-rwxr-xr-x
expiry
30.27
KB
-rwxr-sr-x
expr
50.72
KB
-rwxr-xr-x
extcheck
6.34
KB
-rwxr-xr-x
factor
74.75
KB
-rwxr-xr-x
faillog
22.29
KB
-rwxr-xr-x
faked-sysv
26.56
KB
-rwxr-xr-x
faked-tcp
30.58
KB
-rwxr-xr-x
fakeroot
3.76
KB
-rwxr-xr-x
fakeroot-sysv
3.76
KB
-rwxr-xr-x
fakeroot-tcp
3.76
KB
-rwxr-xr-x
fallocate
30.08
KB
-rwxr-xr-x
fc-cache
18.51
KB
-rwxr-xr-x
fc-cat
18.46
KB
-rwxr-xr-x
fc-conflist
14.27
KB
-rwxr-xr-x
fc-list
14.34
KB
-rwxr-xr-x
fc-match
14.4
KB
-rwxr-xr-x
fc-pattern
14.33
KB
-rwxr-xr-x
fc-query
14.3
KB
-rwxr-xr-x
fc-scan
14.34
KB
-rwxr-xr-x
fc-validate
14.34
KB
-rwxr-xr-x
fcgistarter
13.99
KB
-rwxr-xr-x
filan
83.78
KB
-rwxr-xr-x
file
26.31
KB
-rwxr-xr-x
fincore
30.13
KB
-rwxr-xr-x
find
308.5
KB
-rwxr-xr-x
findaffix
11.74
KB
-rwxr-xr-x
finger
27.08
KB
-rwxr-xr-x
firewall-cmd
113.47
KB
-rwxr-xr-x
firewall-offline-cmd
101.17
KB
-rwxr-xr-x
flock
34.16
KB
-rwxr-xr-x
fmt
42.66
KB
-rwxr-xr-x
fold
38.66
KB
-rwxr-xr-x
formail
46.59
KB
-rwxr-xr-x
free
18.08
KB
-rwxr-xr-x
from
10.24
KB
-rwxr-xr-x
ftp
99.62
KB
-rwxr-xr-x
funzip
22.26
KB
-rwxr-xr-x
g++
1.05
MB
-rwxr-xr-x
g++-8
1.05
MB
-rwxr-xr-x
galera_new_cluster
917
B
-rwxr-xr-x
galera_recovery
3.28
KB
-rwxr-xr-x
gamma4scanimage
13.99
KB
-rwxr-xr-x
gapplication
22.07
KB
-rwxr-xr-x
gawk
658.81
KB
-rwxr-xr-x
gcc
1.05
MB
-rwxr-xr-x
gcc-4.9
813.49
KB
-rwxr-xr-x
gcc-6
926.77
KB
-rwxr-xr-x
gcc-8
1.05
MB
-rwxr-xr-x
gcc-ar
34.47
KB
-rwxr-xr-x
gcc-ar-4.9
24.25
KB
-rwxr-xr-x
gcc-ar-6
26.53
KB
-rwxr-xr-x
gcc-ar-8
34.47
KB
-rwxr-xr-x
gcc-nm
34.47
KB
-rwxr-xr-x
gcc-nm-4.9
24.19
KB
-rwxr-xr-x
gcc-nm-6
26.53
KB
-rwxr-xr-x
gcc-nm-8
34.47
KB
-rwxr-xr-x
gcc-ranlib
34.47
KB
-rwxr-xr-x
gcc-ranlib-4.9
24.19
KB
-rwxr-xr-x
gcc-ranlib-6
26.53
KB
-rwxr-xr-x
gcc-ranlib-8
34.47
KB
-rwxr-xr-x
gcov
672.09
KB
-rwxr-xr-x
gcov-4.9
440.43
KB
-rwxr-xr-x
gcov-6
507.93
KB
-rwxr-xr-x
gcov-8
672.09
KB
-rwxr-xr-x
gcov-dump
511.95
KB
-rwxr-xr-x
gcov-dump-6
439.86
KB
-rwxr-xr-x
gcov-dump-8
511.95
KB
-rwxr-xr-x
gcov-tool
548.02
KB
-rwxr-xr-x
gcov-tool-6
463.92
KB
-rwxr-xr-x
gcov-tool-8
548.02
KB
-rwxr-xr-x
gdbus
50.08
KB
-rwxr-xr-x
gdk-pixbuf-csource
14.01
KB
-rwxr-xr-x
gdk-pixbuf-pixdata
13.99
KB
-rwxr-xr-x
gdk-pixbuf-thumbnailer
18.08
KB
-rwxr-xr-x
gencat
26.6
KB
-rwxr-xr-x
geqn
201.19
KB
-rwxr-xr-x
getconf
34.37
KB
-rwxr-xr-x
getent
35.34
KB
-rwxr-xr-x
getfacl
30.62
KB
-rwxr-xr-x
getkeycodes
14.3
KB
-rwxr-xr-x
getopt
22.07
KB
-rwxr-xr-x
gettext
42.62
KB
-rwxr-xr-x
gettext.sh
4.52
KB
-rwxr-xr-x
gettextize
42.73
KB
-rwxr-xr-x
ghostscript
14.18
KB
-rwxr-xr-x
ginstall-info
47.73
KB
-rwxr-xr-x
gio
86.09
KB
-rwxr-xr-x
gio-querymodules
13.99
KB
-rwxr-xr-x
glib-compile-schemas
46.07
KB
-rwxr-xr-x
gold
2.97
MB
-rwxr-xr-x
gpasswd
82.05
KB
-rwsr-xr-x
gpg
1021.73
KB
-rwxr-xr-x
gpg-agent
396.73
KB
-rwxr-xr-x
gpg-connect-agent
158.85
KB
-rwxr-xr-x
gpg-wks-server
199.05
KB
-rwxr-xr-x
gpg-zip
3.43
KB
-rwxr-xr-x
gpg2
1021.73
KB
-rwxr-xr-x
gpgcompose
853.98
KB
-rwxr-xr-x
gpgconf
166.32
KB
-rwxr-xr-x
gpgparsemail
30.07
KB
-rwxr-xr-x
gpgsm
495.09
KB
-rwxr-xr-x
gpgsplit
82.45
KB
-rwxr-xr-x
gpgtar
151.32
KB
-rwxr-xr-x
gpgv
434.99
KB
-rwxr-xr-x
gpic
208.03
KB
-rwxr-xr-x
gprof
96.39
KB
-rwxr-xr-x
gresource
21.99
KB
-rwxr-xr-x
groff
117.22
KB
-rwxr-xr-x
grog
2.71
KB
-rwxr-xr-x
grops
177.63
KB
-rwxr-xr-x
grotty
129.25
KB
-rwxr-xr-x
groups
38.66
KB
-rwxr-xr-x
grub-editenv
369.96
KB
-rwxr-xr-x
grub-file
801.21
KB
-rwxr-xr-x
grub-fstest
922.9
KB
-rwxr-xr-x
grub-glue-efi
244.77
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
228.85
KB
-rwxr-xr-x
grub-mkfont
269.46
KB
-rwxr-xr-x
grub-mkimage
349.96
KB
-rwxr-xr-x
grub-mklayout
249.09
KB
-rwxr-xr-x
grub-mknetdir
402.76
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
249.15
KB
-rwxr-xr-x
grub-mkrelpath
240.49
KB
-rwxr-xr-x
grub-mkrescue
979.63
KB
-rwxr-xr-x
grub-mkstandalone
487.09
KB
-rwxr-xr-x
grub-mount
745.85
KB
-rwxr-xr-x
grub-ntldr-img
38.38
KB
-rwxr-xr-x
grub-render-label
817.77
KB
-rwxr-xr-x
grub-script-check
264.62
KB
-rwxr-xr-x
grub-syslinux2cfg
766.29
KB
-rwxr-xr-x
gs
14.18
KB
-rwxr-xr-x
gsbj
350
B
-rwxr-xr-x
gsdj
352
B
-rwxr-xr-x
gsdj500
352
B
-rwxr-xr-x
gsettings
30.07
KB
-rwxr-xr-x
gslj
353
B
-rwxr-xr-x
gslp
350
B
-rwxr-xr-x
gsnd
277
B
-rwxr-xr-x
gtbl
138.2
KB
-rwxr-xr-x
gtk-builder-tool
34.42
KB
-rwxr-xr-x
gtk-launch
18.15
KB
-rwxr-xr-x
gtk-query-settings
13.99
KB
-rwxr-xr-x
gtk-update-icon-cache
38.47
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.44
KB
-rwxr-xr-x
hd
26.55
KB
-rwxr-xr-x
head
46.72
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
26.55
KB
-rwxr-xr-x
host
126.63
KB
-rwxr-xr-x
hostid
34.59
KB
-rwxr-xr-x
hostnamectl
26.07
KB
-rwxr-xr-x
hsdb
6.35
KB
-rwxr-xr-x
htcacheclean
34
KB
-rwxr-xr-x
htdbm
25.99
KB
-rwxr-xr-x
htdigest
13.99
KB
-rwxr-xr-x
htpasswd
25.99
KB
-rwxr-xr-x
i386
22.34
KB
-rwxr-xr-x
icombine
34.38
KB
-rwxr-xr-x
iconv
59.01
KB
-rwxr-xr-x
id
42.78
KB
-rwxr-xr-x
idlj
6.34
KB
-rwxr-xr-x
ifnames
4.03
KB
-rwxr-xr-x
ijoin
14.03
KB
-rwxr-xr-x
info
242.79
KB
-rwxr-xr-x
infobrowser
242.79
KB
-rwxr-xr-x
infocmp
62.07
KB
-rwxr-xr-x
infotocap
86.11
KB
-rwxr-xr-x
innochecksum
3.46
MB
-rwxr-xr-x
innotop
445.81
KB
-rwxr-xr-x
install
151.6
KB
-rwxr-xr-x
install-info
47.73
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
30.08
KB
-rwxr-xr-x
ipcmk
30.14
KB
-rwxr-xr-x
ipcrm
30.08
KB
-rwxr-xr-x
ipcs
66.08
KB
-rwxr-xr-x
iptables-xml
100.68
KB
-rwxr-xr-x
ischroot
14.23
KB
-rwxr-xr-x
ispell
94.46
KB
-rwxr-xr-x
ispell-wrapper
7.05
KB
-rwxr-xr-x
jar
6.34
KB
-rwxr-xr-x
jarsigner
6.34
KB
-rwxr-xr-x
java
6.3
KB
-rwxr-xr-x
javac
6.34
KB
-rwxr-xr-x
javadoc
6.34
KB
-rwxr-xr-x
javah
6.34
KB
-rwxr-xr-x
javap
6.34
KB
-rwxr-xr-x
jcmd
6.34
KB
-rwxr-xr-x
jconsole
6.36
KB
-rwxr-xr-x
jdb
6.35
KB
-rwxr-xr-x
jdeps
6.34
KB
-rwxr-xr-x
jexec
10.33
KB
-rwxr-xr-x
jfr
6.34
KB
-rwxr-xr-x
jhat
6.34
KB
-rwxr-xr-x
jinfo
6.38
KB
-rwxr-xr-x
jjs
6.34
KB
-rwxr-xr-x
jmap
6.38
KB
-rwxr-xr-x
join
50.75
KB
-rwxr-xr-x
jps
6.34
KB
-rwxr-xr-x
jrunscript
6.34
KB
-rwxr-xr-x
jsadebugd
6.35
KB
-rwxr-xr-x
json_pp
4.28
KB
-rwxr-xr-x
jstack
6.38
KB
-rwxr-xr-x
jstat
6.34
KB
-rwxr-xr-x
jstatd
6.34
KB
-rwxr-xr-x
kbdinfo
14.31
KB
-rwxr-xr-x
kbxutil
162.66
KB
-rwxr-xr-x
kernel-install
4.53
KB
-rwxr-xr-x
keytool
6.34
KB
-rwxr-xr-x
killall
31.72
KB
-rwxr-xr-x
laptop-detect
3.73
KB
-rwxr-xr-x
last
46.08
KB
-rwxr-xr-x
lastb
46.08
KB
-rwxr-xr-x
lastlog
22.07
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld
1.7
MB
-rwxr-xr-x
ld.bfd
1.7
MB
-rwxr-xr-x
ld.gold
2.97
MB
-rwxr-xr-x
ldd
5.27
KB
-rwxr-xr-x
less
166.76
KB
-rwxr-xr-x
lessecho
14.02
KB
-rwxr-xr-x
lessfile
8.36
KB
-rwxr-xr-x
lesskey
23.39
KB
-rwxr-xr-x
lesspipe
8.36
KB
-rwxr-xr-x
lexgrog
94.57
KB
-rwxr-xr-x
lft
2.43
KB
-rwxr-xr-x
lft.db
2.43
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
libtoolize
128.26
KB
-rwxr-xr-x
link
34.59
KB
-rwxr-xr-x
linux-boot-prober
1.54
KB
-rwxr-xr-x
linux-check-removal
4.56
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
22.34
KB
-rwxr-xr-x
linux64
22.34
KB
-rwxr-xr-x
listres
10.62
KB
-rwxr-xr-x
lnstat
22.74
KB
-rwxr-xr-x
loadkeys
207.14
KB
-rwxr-xr-x
loadunimap
34.61
KB
-rwxr-xr-x
locale
54.04
KB
-rwxr-xr-x
localectl
26.07
KB
-rwxr-xr-x
localedef
299.75
KB
-rwxr-xr-x
locate
38.68
KB
-rwxr-sr-x
lockfile
18.25
KB
-rwxr-sr-x
logger
46.67
KB
-rwxr-xr-x
logname
34.59
KB
-rwxr-xr-x
logresolve
14
KB
-rwxr-xr-x
look
10.49
KB
-rwxr-xr-x
lorder
2.82
KB
-rwxr-xr-x
lsattr
14
KB
-rwxr-xr-x
lsb_release
3.55
KB
-rwxr-xr-x
lscpu
86.08
KB
-rwxr-xr-x
lsinitramfs
706
B
-rwxr-xr-x
lsipc
90.08
KB
-rwxr-xr-x
lslocks
34.41
KB
-rwxr-xr-x
lslogins
66.08
KB
-rwxr-xr-x
lsmem
62.08
KB
-rwxr-xr-x
lsns
50.08
KB
-rwxr-xr-x
lsof
171.47
KB
-rwxr-xr-x
lspci
80.31
KB
-rwxr-xr-x
lspgpot
1.06
KB
-rwxr-xr-x
luit
48.72
KB
-rwxr-xr-x
lwp-download
10.05
KB
-rwxr-xr-x
lwp-dump
2.65
KB
-rwxr-xr-x
lwp-mirror
2.36
KB
-rwxr-xr-x
lwp-request
15.82
KB
-rwxr-xr-x
lzcat
79.29
KB
-rwxr-xr-x
lzcmp
6.48
KB
-rwxr-xr-x
lzdiff
6.48
KB
-rwxr-xr-x
lzegrep
5.76
KB
-rwxr-xr-x
lzfgrep
5.76
KB
-rwxr-xr-x
lzgrep
5.76
KB
-rwxr-xr-x
lzless
1.76
KB
-rwxr-xr-x
lzma
79.29
KB
-rwxr-xr-x
lzmainfo
14.31
KB
-rwxr-xr-x
lzmore
2.11
KB
-rwxr-xr-x
m-a
57.17
KB
-rwxr-xr-x
m4
159.18
KB
-rwxr-xr-x
mac2unix
50.02
KB
-rwxr-xr-x
mail
110.24
KB
-rwxr-xr-x
mailq
1.13
MB
-rwsr-xr-x
mailstat
5.72
KB
-rwxr-xr-x
mailx
110.24
KB
-rwxr-xr-x
make
226.59
KB
-rwxr-xr-x
make-first-existing-target
4.79
KB
-rwxr-xr-x
makeinfo
52.78
KB
-rwxr-xr-x
man
112.5
KB
-rwxr-xr-x
mandb
134.72
KB
-rwxr-xr-x
manpath
34.47
KB
-rwxr-xr-x
mapscrn
26.58
KB
-rwxr-xr-x
mariadb
3.91
MB
-rwxr-xr-x
mariadb-check
3.67
MB
-rwxr-xr-x
mariadb-service-convert
2.45
KB
-rwxr-xr-x
mawk
119.12
KB
-rwxr-xr-x
mc
1011.96
KB
-rwxr-xr-x
mcdiff
1011.96
KB
-rwxr-xr-x
mcedit
1011.96
KB
-rwxr-xr-x
mcookie
34.14
KB
-rwxr-xr-x
mcview
1011.96
KB
-rwxr-xr-x
md5sum
46.72
KB
-rwxr-xr-x
md5sum.textutils
46.72
KB
-rwxr-xr-x
mdig
46.09
KB
-rwxr-xr-x
mesg
14.07
KB
-rwxr-xr-x
migrate-pubring-from-classic-g...
2.99
KB
-rwxr-xr-x
mk_modmap
15.78
KB
-rwxr-xr-x
mkfifo
62.91
KB
-rwxr-xr-x
mkpasswd
26.47
KB
-rwxr-xr-x
mlocate
38.68
KB
-rwxr-sr-x
mlock
14.3
KB
-rwxr-sr-x
module-assistant
57.17
KB
-rwxr-xr-x
msgattrib
26.45
KB
-rwxr-xr-x
msgcat
22.45
KB
-rwxr-xr-x
msgcmp
26.56
KB
-rwxr-xr-x
msgcomm
22.43
KB
-rwxr-xr-x
msgconv
22.41
KB
-rwxr-xr-x
msgen
22.41
KB
-rwxr-xr-x
msgexec
18.45
KB
-rwxr-xr-x
msgfilter
34.54
KB
-rwxr-xr-x
msgfmt
83.37
KB
-rwxr-xr-x
msggrep
42.79
KB
-rwxr-xr-x
msginit
67.17
KB
-rwxr-xr-x
msgmerge
71.39
KB
-rwxr-xr-x
msgunfmt
30.64
KB
-rwxr-xr-x
msguniq
22.42
KB
-rwxr-xr-x
msql2mysql
1.41
KB
-rwxr-xr-x
mtrace
6.32
KB
-rwxr-xr-x
munchlist
31.23
KB
-rwxr-xr-x
mutt
1.02
MB
-rwxr-xr-x
mutt_dotlock
14.01
KB
-rwxr-sr-x
my_print_defaults
3.37
MB
-rwxr-xr-x
myisam_ftdump
3.64
MB
-rwxr-xr-x
myisamchk
3.75
MB
-rwxr-xr-x
myisamlog
3.62
MB
-rwxr-xr-x
myisampack
3.65
MB
-rwxr-xr-x
mysql
3.91
MB
-rwxr-xr-x
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
mysql_embedded
18.94
MB
-rwxr-xr-x
mysql_find_rows
3.21
KB
-rwxr-xr-x
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
mysql_install_db
19.74
KB
-rwxr-xr-x
mysql_plugin
3.37
MB
-rwxr-xr-x
mysql_secure_installation
12.23
KB
-rwxr-xr-x
mysql_setpermission
17.13
KB
-rwxr-xr-x
mysql_tzinfo_to_sql
3.37
MB
-rwxr-xr-x
mysql_upgrade
3.46
MB
-rwxr-xr-x
mysql_waitpid
3.36
MB
-rwxr-xr-x
mysqlaccess
109.3
KB
-rwxr-xr-x
mysqladmin
3.7
MB
-rwxr-xr-x
mysqlanalyze
3.67
MB
-rwxr-xr-x
mysqlbinlog
3.92
MB
-rwxr-xr-x
mysqlcheck
3.67
MB
-rwxr-xr-x
mysqld_multi
26.67
KB
-rwxr-xr-x
mysqld_safe
30.08
KB
-rwxr-xr-x
mysqld_safe_helper
3.33
MB
-rwxr-xr-x
mysqldump
3.75
MB
-rwxr-xr-x
mysqldumpslow
8.05
KB
-rwxr-xr-x
mysqlhotcopy
34.14
KB
-rwxr-xr-x
mysqlimport
3.66
MB
-rwxr-xr-x
mysqloptimize
3.67
MB
-rwxr-xr-x
mysqlrepair
3.67
MB
-rwxr-xr-x
mysqlreport
50.03
KB
-rwxr-xr-x
mysqlshow
3.66
MB
-rwxr-xr-x
mysqlslap
3.68
MB
-rwxr-xr-x
mytop
63.3
KB
-rwxr-xr-x
namei
34.08
KB
-rwxr-xr-x
native2ascii
6.34
KB
-rwxr-xr-x
nawk
658.81
KB
-rwxr-xr-x
ncal
29.15
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netkit-ftp
99.62
KB
-rwxr-xr-x
newaliases
1.13
MB
-rwsr-xr-x
newgrp
43.4
KB
-rwsr-xr-x
ngettext
42.63
KB
-rwxr-xr-x
nice
38.63
KB
-rwxr-xr-x
nl
42.78
KB
-rwxr-xr-x
nload
138.03
KB
-rwxr-xr-x
nm
47.91
KB
-rwxr-xr-x
nohup
38.66
KB
-rwxr-xr-x
nproc
38.66
KB
-rwxr-xr-x
nroff
3.22
KB
-rwxr-xr-x
nsenter
34.28
KB
-rwxr-xr-x
nslookup
134.51
KB
-rwxr-xr-x
nstat
79.14
KB
-rwxr-xr-x
nsupdate
70.02
KB
-rwxr-xr-x
numfmt
62.81
KB
-rwxr-xr-x
objcopy
175.42
KB
-rwxr-xr-x
objdump
345.55
KB
-rwxr-xr-x
od
70.78
KB
-rwxr-xr-x
openssl
719.52
KB
-rwxr-xr-x
orbd
6.39
KB
-rwxr-xr-x
os-prober
4.44
KB
-rwxr-xr-x
pack200
6.34
KB
-rwxr-xr-x
pager
166.76
KB
-rwxr-xr-x
paperconf
14.29
KB
-rwxr-xr-x
parsechangelog
8.63
KB
-rwxr-xr-x
partx
106.08
KB
-rwxr-xr-x
passwd
62.24
KB
-rwsr-xr-x
paste
38.66
KB
-rwxr-xr-x
patch
183.44
KB
-rwxr-xr-x
pathchk
38.63
KB
-rwxr-xr-x
pcimodules
14.59
KB
-rwxr-xr-x
pcre-config
2.29
KB
-rwxr-xr-x
pcre2-config
1.93
KB
-rwxr-xr-x
pdb
45.02
KB
-rwxr-xr-x
pdb2
45.02
KB
-rwxr-xr-x
pdb2.7
45.02
KB
-rwxr-xr-x
pdb3
61.08
KB
-rwxr-xr-x
pdb3.7
61.08
KB
-rwxr-xr-x
pdf2dsc
698
B
-rwxr-xr-x
pdf2ps
909
B
-rwxr-xr-x
pdftexi2dvi
1.27
KB
-rwxr-xr-x
pear
793
B
-rwxr-xr-x
peardev
814
B
-rwxr-xr-x
pecl
727
B
-rwxr-xr-x
peekfd
14.28
KB
-rwxr-xr-x
perf
528
B
-rwxr-xr-x
perl
3.05
MB
-rwxr-xr-x
perl5.28-x86_64-linux-gnu
14.17
KB
-rwxr-xr-x
perl5.28.1
3.05
MB
-rwxr-xr-x
perlbug
45.28
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
45.28
KB
-rwxr-xr-x
perror
3.55
MB
-rwxr-xr-x
pf2afm
498
B
-rwxr-xr-x
pfbtopfa
516
B
-rwxr-xr-x
pftp
99.62
KB
-rwxr-xr-x
pgrep
26.09
KB
-rwxr-xr-x
phar
14.88
KB
-rwxr-xr-x
phar.phar
14.88
KB
-rwxr-xr-x
phar.phar5.6
14.48
KB
-rwxr-xr-x
phar.phar7.0
14.48
KB
-rwxr-xr-x
phar.phar7.2
14.47
KB
-rwxr-xr-x
phar.phar7.3
14.47
KB
-rwxr-xr-x
phar.phar7.4
14.54
KB
-rwxr-xr-x
phar.phar8.2
14.88
KB
-rwxr-xr-x
phar5
14.48
KB
-rwxr-xr-x
phar5.6
14.48
KB
-rwxr-xr-x
phar7.0
14.48
KB
-rwxr-xr-x
phar7.2
14.47
KB
-rwxr-xr-x
phar7.3
14.47
KB
-rwxr-xr-x
phar7.4
14.54
KB
-rwxr-xr-x
phar7.4.phar
14.54
KB
-rwxr-xr-x
phar8.2
14.88
KB
-rwxr-xr-x
phar8.2.phar
14.88
KB
-rwxr-xr-x
php
4.53
MB
-rwxr-xr-x
php-cgi
4.43
MB
-rwxr-xr-x
php-cgi7.2
4.68
MB
-rwxr-xr-x
php-cgi7.3
4.47
MB
-rwxr-xr-x
php-cgi7.4
4.43
MB
-rwxr-xr-x
php-config
4.24
KB
-rwxr-xr-x
php-config7.2
4.14
KB
-rwxr-xr-x
php-config7.3
4.11
KB
-rwxr-xr-x
php-config7.4
4.24
KB
-rwxr-xr-x
php5
8.66
MB
-rwxr-xr-x
php5.6
4.3
MB
-rwxr-xr-x
php7.0
4.3
MB
-rwxr-xr-x
php7.2
4.79
MB
-rwxr-xr-x
php7.3
4.57
MB
-rwxr-xr-x
php7.4
4.53
MB
-rwxr-xr-x
php8.2
5.37
MB
-rwxr-xr-x
phpdbg
4.65
MB
-rwxr-xr-x
phpdbg7.2
4.91
MB
-rwxr-xr-x
phpdbg7.3
4.69
MB
-rwxr-xr-x
phpdbg7.4
4.65
MB
-rwxr-xr-x
phpize
4.81
KB
-rwxr-xr-x
phpize7.2
4.84
KB
-rwxr-xr-x
phpize7.3
4.87
KB
-rwxr-xr-x
phpize7.4
4.81
KB
-rwxr-xr-x
pic
208.03
KB
-rwxr-xr-x
pico
240.39
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pigz
114.2
KB
-rwxr-xr-x
pinentry
86.49
KB
-rwxr-xr-x
pinentry-gtk-2
86.49
KB
-rwxr-xr-x
pinentry-x11
86.49
KB
-rwxr-xr-x
pinky
42.81
KB
-rwxr-xr-x
pkaction
14.31
KB
-rwxr-xr-x
pkcheck
22.66
KB
-rwxr-xr-x
pkcon
71.71
KB
-rwxr-xr-x
pkg-config
54.83
KB
-rwxr-xr-x
pkgtools
1.34
KB
-rwxr-xr-x
pkill
26.09
KB
-rwxr-xr-x
pkmon
22.49
KB
-rwxr-xr-x
pkttyagent
18.37
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.57
KB
-rwxr-xr-x
pmap
30.09
KB
-rwxr-xr-x
po2debconf
8.47
KB
-rwxr-xr-x
pod2html
4.04
KB
-rwxr-xr-x
pod2man
14.86
KB
-rwxr-xr-x
pod2texi
19.65
KB
-rwxr-xr-x
pod2text
10.85
KB
-rwxr-xr-x
pod2usage
3.86
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
podebconf-display-po
12.67
KB
-rwxr-xr-x
podebconf-report-po
31.76
KB
-rwxr-xr-x
podselect
2.47
KB
-rwxr-xr-x
policytool
6.34
KB
-rwxr-xr-x
pphs
404
B
-rwxr-xr-x
pr
74.94
KB
-rwxr-xr-x
precat
5.52
KB
-rwxr-xr-x
preconv
66.2
KB
-rwxr-xr-x
preunzip
5.52
KB
-rwxr-xr-x
prezip
5.52
KB
-rwxr-xr-x
prezip-bin
13.99
KB
-rwxr-xr-x
print
17.74
KB
-rwxr-xr-x
printafm
395
B
-rwxr-xr-x
printenv
34.59
KB
-rwxr-xr-x
printerbanner
22.23
KB
-rwxr-xr-x
printf
54.69
KB
-rwxr-xr-x
prlimit
38.59
KB
-rwxr-xr-x
procan
71.68
KB
-rwxr-xr-x
procmail
95.2
KB
-rwsr-sr-x
prove
13.33
KB
-rwxr-xr-x
prtstat
18.36
KB
-rwxr-xr-x
ps2ascii
631
B
-rwxr-xr-x
ps2epsi
2.69
KB
-rwxr-xr-x
ps2pdf
272
B
-rwxr-xr-x
ps2pdf12
215
B
-rwxr-xr-x
ps2pdf13
215
B
-rwxr-xr-x
ps2pdf14
215
B
-rwxr-xr-x
ps2pdfwr
1.07
KB
-rwxr-xr-x
ps2ps
647
B
-rwxr-xr-x
ps2ps2
669
B
-rwxr-xr-x
ps2txt
631
B
-rwxr-xr-x
psfaddtable
22.31
KB
-rwxr-xr-x
psfgettable
22.31
KB
-rwxr-xr-x
psfstriptable
22.31
KB
-rwxr-xr-x
psfxtable
22.31
KB
-rwxr-xr-x
pslog
14.23
KB
-rwxr-xr-x
pstree
31.48
KB
-rwxr-xr-x
pstree.x11
31.48
KB
-rwxr-xr-x
ptar
3.47
KB
-rwxr-xr-x
ptardiff
2.57
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
74.91
KB
-rwxr-xr-x
pwdx
10.07
KB
-rwxr-xr-x
py3clean
7.62
KB
-rwxr-xr-x
py3compile
11.83
KB
-rwxr-xr-x
py3versions
11.44
KB
-rwxr-xr-x
pyclean
4.03
KB
-rwxr-xr-x
pycompile
11.62
KB
-rwxr-xr-x
pydoc
79
B
-rwxr-xr-x
pydoc2
79
B
-rwxr-xr-x
pydoc2.7
79
B
-rwxr-xr-x
pydoc3
79
B
-rwxr-xr-x
pydoc3.7
79
B
-rwxr-xr-x
pygettext
21.56
KB
-rwxr-xr-x
pygettext2
21.56
KB
-rwxr-xr-x
pygettext2.7
21.56
KB
-rwxr-xr-x
pygettext3
21.04
KB
-rwxr-xr-x
pygettext3.7
21.04
KB
-rwxr-xr-x
python
3.51
MB
-rwxr-xr-x
python2
3.51
MB
-rwxr-xr-x
python2.7
3.51
MB
-rwxr-xr-x
python3
4.65
MB
-rwxr-xr-x
python3.7
4.65
MB
-rwxr-xr-x
python3.7m
4.65
MB
-rwxr-xr-x
python3m
4.65
MB
-rwxr-xr-x
pyversions
14.76
KB
-rwxr-xr-x
querybts
10.75
KB
-rwxr-xr-x
ranlib
63.1
KB
-rwxr-xr-x
rcp
98.14
KB
-rwxr-xr-x
rdma
107.16
KB
-rwxr-xr-x
readelf
583.06
KB
-rwxr-xr-x
realpath
46.69
KB
-rwxr-xr-x
recode-sr-latin
14.4
KB
-rwxr-xr-x
rename.ul
22.07
KB
-rwxr-xr-x
renice
14.07
KB
-rwxr-xr-x
replace
3.34
MB
-rwxr-xr-x
report-hw
2.05
KB
-rwxr-xr-x
reportbug
105.14
KB
-rwxr-xr-x
reset
30
KB
-rwxr-xr-x
resizecons
22.58
KB
-rwxr-xr-x
resizepart
58.08
KB
-rwxr-xr-x
resolve_stack_dump
3.37
MB
-rwxr-xr-x
resolvectl
114.22
KB
-rwxr-xr-x
resolveip
3.36
MB
-rwxr-xr-x
rev
14.07
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rlogin
714.79
KB
-rwxr-xr-x
rmic
6.34
KB
-rwxr-xr-x
rmid
6.34
KB
-rwxr-xr-x
rmiregistry
6.34
KB
-rwxr-xr-x
rotatelogs
26.07
KB
-rwxr-xr-x
routef
208
B
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
90.98
KB
-rwxr-xr-x
rpcinfo
34.16
KB
-rwxr-xr-x
rsh
714.79
KB
-rwxr-xr-x
rsync
488.37
KB
-rwxr-xr-x
rtstat
22.74
KB
-rwxr-xr-x
run-mailcap
17.74
KB
-rwxr-xr-x
run-with-aspell
57
B
-rwxr-xr-x
runcon
38.72
KB
-rwxr-xr-x
rview
2.58
MB
-rwxr-xr-x
rvim
2.58
MB
-rwxr-xr-x
sane-find-scanner
114.7
KB
-rwxr-xr-x
savelog
10.22
KB
-rwxr-xr-x
scanimage
50.77
KB
-rwxr-xr-x
schemagen
6.34
KB
-rwxr-xr-x
scp
98.14
KB
-rwxr-xr-x
screendump
14.29
KB
-rwxr-xr-x
script
50.08
KB
-rwxr-xr-x
scriptreplay
30.08
KB
-rwxr-xr-x
sdiff
50.77
KB
-rwxr-xr-x
see
17.74
KB
-rwxr-xr-x
select-default-iwrap
474
B
-rwxr-xr-x
select-editor
2.38
KB
-rwxr-xr-x
sensible-browser
1.18
KB
-rwxr-xr-x
sensible-editor
1.08
KB
-rwxr-xr-x
sensible-pager
433
B
-rwxr-xr-x
seq
50.69
KB
-rwxr-xr-x
serialver
6.34
KB
-rwxr-xr-x
servertool
6.34
KB
-rwxr-xr-x
setarch
22.34
KB
-rwxr-xr-x
setfacl
38.68
KB
-rwxr-xr-x
setkeycodes
14.3
KB
-rwxr-xr-x
setleds
14.29
KB
-rwxr-xr-x
setlogcons
14.3
KB
-rwxr-xr-x
setmetamode
14.34
KB
-rwxr-xr-x
setpci
22.54
KB
-rwxr-xr-x
setpriv
42.08
KB
-rwxr-xr-x
setsid
14.07
KB
-rwxr-xr-x
setterm
42.08
KB
-rwxr-xr-x
setvtrgb
14.42
KB
-rwxr-xr-x
sftp
150.35
KB
-rwxr-xr-x
sg
43.4
KB
-rwsr-xr-x
sha1sum
50.72
KB
-rwxr-xr-x
sha224sum
54.72
KB
-rwxr-xr-x
sha256sum
54.72
KB
-rwxr-xr-x
sha384sum
62.72
KB
-rwxr-xr-x
sha512sum
62.72
KB
-rwxr-xr-x
shasum
9.74
KB
-rwxr-xr-x
showconsolefont
18.38
KB
-rwxr-xr-x
showkey
18.34
KB
-rwxr-xr-x
shred
58.94
KB
-rwxr-xr-x
shtool
138.76
KB
-rwxr-xr-x
shtoolize
15.16
KB
-rwxr-xr-x
shuf
58.81
KB
-rwxr-xr-x
size
34.97
KB
-rwxr-xr-x
skill
26.08
KB
-rwxr-xr-x
slabtop
18.08
KB
-rwxr-xr-x
slogin
714.79
KB
-rwxr-xr-x
smime_keys
30.08
KB
-rwxr-xr-x
snice
26.08
KB
-rwxr-xr-x
socat
369.43
KB
-rwxr-xr-x
soelim
42.2
KB
-rwxr-xr-x
sort
111.45
KB
-rwxr-xr-x
sotruss
4.18
KB
-rwxr-xr-x
splain
18.7
KB
-rwxr-xr-x
split
59.32
KB
-rwxr-xr-x
splitfont
14.19
KB
-rwxr-xr-x
sprof
26.69
KB
-rwxr-xr-x
sq
5.99
KB
-rwxr-xr-x
ssh
714.79
KB
-rwxr-xr-x
ssh-add
334.13
KB
-rwxr-xr-x
ssh-agent
314.13
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
10.41
KB
-rwxr-xr-x
ssh-keygen
406.15
KB
-rwxr-xr-x
ssh-keyscan
410.15
KB
-rwxr-xr-x
stat
79.03
KB
-rwxr-xr-x
stdbuf
50.69
KB
-rwxr-xr-x
strings
31.13
KB
-rwxr-xr-x
strip
175.43
KB
-rwxr-xr-x
sudo
153.51
KB
-rwsr-xr-x
sudoedit
153.51
KB
-rwsr-xr-x
sudoreplay
62.84
KB
-rwxr-xr-x
sum
42.73
KB
-rwxr-xr-x
symcryptrun
118.73
KB
-rwxr-xr-x
systemd-analyze
1.38
MB
-rwxr-xr-x
systemd-cat
14.08
KB
-rwxr-xr-x
systemd-cgls
18.17
KB
-rwxr-xr-x
systemd-cgtop
38.09
KB
-rwxr-xr-x
systemd-delta
26.07
KB
-rwxr-xr-x
systemd-detect-virt
14.06
KB
-rwxr-xr-x
systemd-id128
14.06
KB
-rwxr-xr-x
systemd-mount
46.29
KB
-rwxr-xr-x
systemd-path
18.06
KB
-rwxr-xr-x
systemd-resolve
114.22
KB
-rwxr-xr-x
systemd-run
50.27
KB
-rwxr-xr-x
systemd-socket-activate
26.07
KB
-rwxr-xr-x
systemd-stdio-bridge
18.07
KB
-rwxr-xr-x
systemd-umount
46.29
KB
-rwxr-xr-x
tabs
17.99
KB
-rwxr-xr-x
tac
42.72
KB
-rwxr-xr-x
tail
70.91
KB
-rwxr-xr-x
tasksel
16.1
KB
-rwxr-xr-x
taskset
34.08
KB
-rwxr-xr-x
tbl
138.2
KB
-rwxr-xr-x
tee
38.72
KB
-rwxr-xr-x
telnet
113.37
KB
-rwxr-xr-x
telnet.netkit
113.37
KB
-rwxr-xr-x
test
50.66
KB
-rwxr-xr-x
texi2any
52.78
KB
-rwxr-xr-x
texi2dvi
60.31
KB
-rwxr-xr-x
texi2pdf
1.27
KB
-rwxr-xr-x
texindex
3.96
KB
-rwxr-xr-x
tic
86.11
KB
-rwxr-xr-x
time
14.73
KB
-rwxr-xr-x
timedatectl
38.07
KB
-rwxr-xr-x
timeout
43.26
KB
-rwxr-xr-x
tload
14.09
KB
-rwxr-xr-x
tnameserv
6.39
KB
-rwxr-xr-x
toe
21.99
KB
-rwxr-xr-x
top
113.89
KB
-rwxr-xr-x
touch
94.88
KB
-rwxr-xr-x
tput
22.02
KB
-rwxr-xr-x
tr
50.69
KB
-rwxr-xr-x
traceproto
2.82
KB
-rwxr-xr-x
traceproto.db
2.82
KB
-rwxr-xr-x
traceroute
67.16
KB
-rwxr-xr-x
traceroute-nanog
1.58
KB
-rwxr-xr-x
traceroute.db
67.16
KB
-rwxr-xr-x
traceroute6
67.16
KB
-rwxr-xr-x
traceroute6.db
67.16
KB
-rwxr-xr-x
troff
723.59
KB
-rwxr-xr-x
truncate
42.66
KB
-rwxr-xr-x
tryaffix
4.8
KB
-rwxr-xr-x
tset
30
KB
-rwxr-xr-x
tsort
42.66
KB
-rwxr-xr-x
tty
34.63
KB
-rwxr-xr-x
txixml2texi
14.67
KB
-rwxr-xr-x
tzselect
15.01
KB
-rwxr-xr-x
ucf
39.73
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.47
KB
-rwxr-xr-x
ul
14.3
KB
-rwxr-xr-x
umax_pp
179.07
KB
-rwxr-xr-x
unattended-upgrade
83.83
KB
-rwxr-xr-x
unattended-upgrades
83.83
KB
-rwxr-xr-x
unexpand
42.69
KB
-rwxr-xr-x
unicode_stop
530
B
-rwxr-xr-x
uniq
50.75
KB
-rwxr-xr-x
unix2dos
50.02
KB
-rwxr-xr-x
unix2mac
50.02
KB
-rwxr-xr-x
unlink
34.59
KB
-rwxr-xr-x
unlzma
79.29
KB
-rwxr-xr-x
unmkinitramfs
3.51
KB
-rwxr-xr-x
unpack200
101.48
KB
-rwxr-xr-x
unpigz
114.2
KB
-rwxr-xr-x
unshare
26.27
KB
-rwxr-xr-x
unsq
5.99
KB
-rwxr-xr-x
unxz
79.29
KB
-rwxr-xr-x
unzip
178.84
KB
-rwxr-xr-x
unzipsfx
82.66
KB
-rwxr-xr-x
update-alternatives
54.25
KB
-rwxr-xr-x
update-mime-database
55.19
KB
-rwxr-xr-x
update-perl-sax-parsers
6.03
KB
-rwxr-xr-x
updatedb
46.82
KB
-rwxr-xr-x
updatedb.mlocate
46.82
KB
-rwxr-xr-x
uptime
10.07
KB
-rwxr-xr-x
users
34.66
KB
-rwxr-xr-x
utmpdump
30.07
KB
-rwxr-xr-x
vi
2.58
MB
-rwxr-xr-x
view
2.58
MB
-rwxr-xr-x
viewres
27.38
KB
-rwxr-xr-x
vim
2.58
MB
-rwxr-xr-x
vim.basic
2.58
MB
-rwxr-xr-x
vim.tiny
1.15
MB
-rwxr-xr-x
vimdiff
2.58
MB
-rwxr-xr-x
vimtutor
2.07
KB
-rwxr-xr-x
vmstat
34.09
KB
-rwxr-xr-x
volname
5.99
KB
-rwxr-xr-x
w
18.07
KB
-rwxr-xr-x
w.procps
18.07
KB
-rwxr-xr-x
w3m
1.4
MB
-rwxr-xr-x
w3mman
1.18
KB
-rwxr-xr-x
wall
34.08
KB
-rwxr-xr-x
watch
26.41
KB
-rwxr-xr-x
watchgnupg
17.99
KB
-rwxr-xr-x
wc
46.76
KB
-rwxr-xr-x
wget
455.56
KB
-rwxr-xr-x
whatis
54.98
KB
-rwxr-xr-x
whereis
30.51
KB
-rwxr-xr-x
which
946
B
-rwxr-xr-x
whiptail
26.7
KB
-rwxr-xr-x
who
54.81
KB
-rwxr-xr-x
whoami
34.63
KB
-rwxr-xr-x
whois
153.27
KB
-rwxr-xr-x
word-list-compress
13.99
KB
-rwxr-xr-x
write
14.39
KB
-rwxr-sr-x
wsgen
6.34
KB
-rwxr-xr-x
wsimport
6.34
KB
-rwxr-xr-x
wsrep_sst_common
54.05
KB
-rwxr-xr-x
wsrep_sst_mariabackup
50.87
KB
-rwxr-xr-x
wsrep_sst_mysqldump
7.67
KB
-rwxr-xr-x
wsrep_sst_rsync
32.17
KB
-rwxr-xr-x
wsrep_sst_rsync_wan
32.17
KB
-rwxr-xr-x
www-browser
1.4
MB
-rwxr-xr-x
x86_64
22.34
KB
-rwxr-xr-x
x86_64-linux-gnu-addr2line
31.09
KB
-rwxr-xr-x
x86_64-linux-gnu-ar
63.07
KB
-rwxr-xr-x
x86_64-linux-gnu-as
872.93
KB
-rwxr-xr-x
x86_64-linux-gnu-c++filt
30.69
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-cpp-4.9
814.43
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp-6
930.77
KB
-rwxr-xr-x
x86_64-linux-gnu-cpp-8
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-dwp
2.74
MB
-rwxr-xr-x
x86_64-linux-gnu-elfedit
38.84
KB
-rwxr-xr-x
x86_64-linux-gnu-g++
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-g++-8
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-4.9
813.49
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-6
926.77
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-8
1.05
MB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-4.9
24.25
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-6
26.53
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ar-8
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-4.9
24.19
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-6
26.53
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-nm-8
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-4....
24.19
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-6
26.53
KB
-rwxr-xr-x
x86_64-linux-gnu-gcc-ranlib-8
34.47
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov
672.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-4.9
440.43
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-6
507.93
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-8
672.09
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump
511.95
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-6
439.86
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-dump-8
511.95
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool
548.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-6
463.92
KB
-rwxr-xr-x
x86_64-linux-gnu-gcov-tool-8
548.02
KB
-rwxr-xr-x
x86_64-linux-gnu-gold
2.97
MB
-rwxr-xr-x
x86_64-linux-gnu-gprof
96.39
KB
-rwxr-xr-x
x86_64-linux-gnu-ld
1.7
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.bfd
1.7
MB
-rwxr-xr-x
x86_64-linux-gnu-ld.gold
2.97
MB
-rwxr-xr-x
x86_64-linux-gnu-nm
47.91
KB
-rwxr-xr-x
x86_64-linux-gnu-objcopy
175.42
KB
-rwxr-xr-x
x86_64-linux-gnu-objdump
345.55
KB
-rwxr-xr-x
x86_64-linux-gnu-pkg-config
2
KB
-rwxr-xr-x
x86_64-linux-gnu-ranlib
63.1
KB
-rwxr-xr-x
x86_64-linux-gnu-readelf
583.06
KB
-rwxr-xr-x
x86_64-linux-gnu-size
34.97
KB
-rwxr-xr-x
x86_64-linux-gnu-strings
31.13
KB
-rwxr-xr-x
x86_64-linux-gnu-strip
175.43
KB
-rwxr-xr-x
x86_64-pc-linux-gnu-pkg-config
54.83
KB
-rwxr-xr-x
xargs
70.21
KB
-rwxr-xr-x
xauth
47.45
KB
-rwxr-xr-x
xdg-user-dir
234
B
-rwxr-xr-x
xdg-user-dirs-update
26.07
KB
-rwxr-xr-x
xdpyinfo
31.49
KB
-rwxr-xr-x
xdriinfo
10.19
KB
-rwxr-xr-x
xev
30.96
KB
-rwxr-xr-x
xfd
32.33
KB
-rwxr-xr-x
xfontsel
40.33
KB
-rwxr-xr-x
xgettext
269.8
KB
-rwxr-xr-x
xjc
6.34
KB
-rwxr-xr-x
xkill
14.32
KB
-rwxr-xr-x
xlsatoms
10.26
KB
-rwxr-xr-x
xlsclients
14.34
KB
-rwxr-xr-x
xlsfonts
18.44
KB
-rwxr-xr-x
xmessage
23.33
KB
-rwxr-xr-x
xprop
40.9
KB
-rwxr-xr-x
xsubpp
5.04
KB
-rwxr-xr-x
xvinfo
14.26
KB
-rwxr-xr-x
xwininfo
42.78
KB
-rwxr-xr-x
xxd
18.12
KB
-rwxr-xr-x
xz
79.29
KB
-rwxr-xr-x
xzcat
79.29
KB
-rwxr-xr-x
xzcmp
6.48
KB
-rwxr-xr-x
xzdiff
6.48
KB
-rwxr-xr-x
xzegrep
5.76
KB
-rwxr-xr-x
xzfgrep
5.76
KB
-rwxr-xr-x
xzgrep
5.76
KB
-rwxr-xr-x
xzless
1.76
KB
-rwxr-xr-x
xzmore
2.11
KB
-rwxr-xr-x
yes
34.59
KB
-rwxr-xr-x
zdump
18.4
KB
-rwxr-xr-x
zipdetails
47.36
KB
-rwxr-xr-x
zipgrep
2.88
KB
-rwxr-xr-x
zipinfo
178.84
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : apt-key
#!/bin/sh set -e unset GREP_OPTIONS GPGHOMEDIR CURRENTTRAP export IFS="$(printf "\n\b")" MASTER_KEYRING='' eval "$(apt-config shell MASTER_KEYRING APT::Key::MasterKeyring)" ARCHIVE_KEYRING='' eval "$(apt-config shell ARCHIVE_KEYRING APT::Key::ArchiveKeyring)" REMOVED_KEYS='' eval "$(apt-config shell REMOVED_KEYS APT::Key::RemovedKeys)" ARCHIVE_KEYRING_URI='' eval "$(apt-config shell ARCHIVE_KEYRING_URI APT::Key::ArchiveKeyringURI)" aptkey_echo() { echo "$@"; } find_gpgv_status_fd() { while [ -n "$1" ]; do if [ "$1" = '--status-fd' ]; then shift echo "$1" break fi shift done } GPGSTATUSFD="$(find_gpgv_status_fd "$@")" apt_warn() { if [ -z "$GPGHOMEDIR" ]; then echo >&2 'W:' "$@" else echo 'W:' "$@" > "${GPGHOMEDIR}/aptwarnings.log" fi if [ -n "$GPGSTATUSFD" ]; then echo >&${GPGSTATUSFD} '[APTKEY:] WARNING' "$@" fi } apt_error() { if [ -z "$GPGHOMEDIR" ]; then echo >&2 'E:' "$@" else echo 'E:' "$@" > "${GPGHOMEDIR}/aptwarnings.log" fi if [ -n "$GPGSTATUSFD" ]; then echo >&${GPGSTATUSFD} '[APTKEY:] ERROR' "$@" fi } cleanup_gpg_home() { if [ -z "$GPGHOMEDIR" ]; then return; fi if [ -s "$GPGHOMEDIR/aptwarnings.log" ]; then cat >&2 "$GPGHOMEDIR/aptwarnings.log" fi if command_available 'gpgconf'; then GNUPGHOME="${GPGHOMEDIR}" gpgconf --kill all >/dev/null 2>&1 || true fi rm -rf "$GPGHOMEDIR" } # gpg needs (in different versions more or less) files to function correctly, # so we give it its own homedir and generate some valid content for it later on create_gpg_home() { # for cases in which we want to cache a homedir due to expensive setup if [ -n "$GPGHOMEDIR" ]; then return fi if [ -n "$TMPDIR" ]; then # tmpdir is a directory and current user has rwx access to it # same tests as in apt-pkg/contrib/fileutl.cc GetTempDir() if [ ! -d "$TMPDIR" ] || [ ! -r "$TMPDIR" ] || [ ! -w "$TMPDIR" ] || [ ! -x "$TMPDIR" ]; then unset TMPDIR fi fi GPGHOMEDIR="$(mktemp --directory --tmpdir 'apt-key-gpghome.XXXXXXXXXX')" CURRENTTRAP="${CURRENTTRAP} cleanup_gpg_home;" trap "${CURRENTTRAP}" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM if [ -z "$GPGHOMEDIR" ]; then apt_error "Could not create temporary gpg home directory in $TMPDIR (wrong permissions?)" exit 28 fi chmod 700 "$GPGHOMEDIR" } requires_root() { if [ "$(id -u)" -ne 0 ]; then apt_error "This command can only be used by root." exit 1 fi } command_available() { if [ -x "$1" ]; then return 0; fi # command -v "$1" >/dev/null 2>&1 # not required by policy, see #747320 # which "$1" >/dev/null 2>&1 # is in debianutils (essential) but not on non-debian systems local OLDIFS="$IFS" IFS=: for p in $PATH; do if [ -x "${p}/${1}" ]; then IFS="$OLDIFS" return 0 fi done IFS="$OLDIFS" return 1 } escape_shell() { echo "$@" | sed -e "s#'#'\"'\"'#g" } get_fingerprints_of_keyring() { aptkey_execute "$GPG_SH" --keyring "$1" --with-colons --fingerprint | while read publine; do # search for a public key if [ "${publine%%:*}" != 'pub' ]; then continue; fi # search for the associated fingerprint (should be the very next line) while read fprline; do if [ "${fprline%%:*}" = 'sub' ]; then break; # should never happen elif [ "${fprline%%:*}" != 'fpr' ]; then continue; fi echo "$fprline" | cut -d':' -f 10 done # order in the keyring shouldn't be important done | sort } add_keys_with_verify_against_master_keyring() { ADD_KEYRING="$1" MASTER="$2" if [ ! -f "$ADD_KEYRING" ]; then apt_error "Keyring '$ADD_KEYRING' to be added not found" return fi if [ ! -f "$MASTER" ]; then apt_error "Master-Keyring '$MASTER' not found" return fi # when adding new keys, make sure that the archive-master-keyring # is honored. so: # all keys that are exported must have a valid signature # from a key in the $distro-master-keyring add_keys="$(get_fingerprints_of_keyring "$ADD_KEYRING")" all_add_keys="$(aptkey_execute "$GPG_SH" --keyring "$ADD_KEYRING" --with-colons --list-keys | grep ^[ps]ub | cut -d: -f5)" master_keys="$(aptkey_execute "$GPG_SH" --keyring "$MASTER" --with-colons --list-keys | grep ^pub | cut -d: -f5)" # ensure there are no colisions LP: #857472 for all_add_key in $all_add_keys; do for master_key in $master_keys; do if [ "$all_add_key" = "$master_key" ]; then echo >&2 "Keyid collision for '$all_add_key' detected, operation aborted" return 1 fi done done for add_key in $add_keys; do # export the add keyring one-by-one local TMP_KEYRING="${GPGHOMEDIR}/tmp-keyring.gpg" aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --output "$TMP_KEYRING" --export "$add_key" if ! aptkey_execute "$GPG_SH" --batch --yes --keyring "$TMP_KEYRING" --import "$MASTER" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi # check if signed with the master key and only add in this case ADDED=0 for master_key in $master_keys; do if aptkey_execute "$GPG_SH" --keyring "$TMP_KEYRING" --check-sigs --with-colons "$add_key" \ | grep '^sig:!:' | cut -d: -f5 | grep -q "$master_key"; then aptkey_execute "$GPG_SH" --batch --yes --keyring "$ADD_KEYRING" --export "$add_key" \ | aptkey_execute "$GPG" --batch --yes --import ADDED=1 fi done if [ $ADDED = 0 ]; then echo >&2 "Key '$add_key' not added. It is not signed with a master key" fi rm -f "${TMP_KEYRING}" done } # update the current archive signing keyring from a network URI # the archive-keyring keys needs to be signed with the master key # (otherwise it does not make sense from a security POV) net_update() { local APT_DIR='/' eval $(apt-config shell APT_DIR Dir) # Disabled for now as code is insecure (LP: #1013639 (and 857472, 1013128)) APT_KEY_NET_UPDATE_ENABLED="" eval $(apt-config shell APT_KEY_NET_UPDATE_ENABLED APT::Key::Net-Update-Enabled) if [ -z "$APT_KEY_NET_UPDATE_ENABLED" ]; then exit 1 fi if [ -z "$ARCHIVE_KEYRING_URI" ]; then apt_error 'Your distribution is not supported in net-update as no uri for the archive-keyring is set' exit 1 fi # in theory we would need to depend on wget for this, but this feature # isn't usable in debian anyway as we have no keyring uri nor a master key if ! command_available 'wget'; then apt_error 'wget is required for a network-based update, but it is not installed' exit 1 fi if [ ! -d "${APT_DIR}/var/lib/apt/keyrings" ]; then mkdir -p "${APT_DIR}/var/lib/apt/keyrings" fi keyring="${APT_DIR}/var/lib/apt/keyrings/$(basename "$ARCHIVE_KEYRING_URI")" old_mtime=0 if [ -e $keyring ]; then old_mtime=$(stat -c %Y "$keyring") fi (cd "${APT_DIR}/var/lib/apt/keyrings"; wget --timeout=90 -q -N "$ARCHIVE_KEYRING_URI") if [ ! -e "$keyring" ]; then return fi new_mtime=$(stat -c %Y "$keyring") if [ $new_mtime -ne $old_mtime ]; then aptkey_echo "Checking for new archive signing keys now" add_keys_with_verify_against_master_keyring "$keyring" "$MASTER_KEYRING" fi } update() { if [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then echo >&2 "Warning: 'apt-key update' is deprecated and should not be used anymore!" if [ -z "$ARCHIVE_KEYRING" ]; then echo >&2 "Note: In your distribution this command is a no-op and can therefore be removed safely." exit 0 fi fi if [ ! -f "$ARCHIVE_KEYRING" ]; then apt_error "Can't find the archive-keyring (Is the debian-archive-keyring package installed?)" exit 1 fi # add new keys from the package; # we do not use add_keys_with_verify_against_master_keyring here, # because "update" is run on regular package updates. A # attacker might as well replace the master-archive-keyring file # in the package and add his own keys. so this check wouldn't # add any security. we *need* this check on net-update though import_keyring_into_keyring "$ARCHIVE_KEYRING" '' && cat "${GPGHOMEDIR}/gpgoutput.log" if [ -r "$REMOVED_KEYS" ]; then # remove no-longer supported/used keys get_fingerprints_of_keyring "$(dearmor_filename "$REMOVED_KEYS")" | while read key; do foreach_keyring_do 'remove_key_from_keyring' "$key" done else apt_warn "Removed keys keyring '$REMOVED_KEYS' missing or not readable" fi } remove_key_from_keyring() { local KEYRINGFILE="$1" shift # non-existent keyrings have by definition no keys if [ ! -e "$KEYRINGFILE" ]; then return fi local FINGERPRINTS="${GPGHOMEDIR}/keyringfile.keylst" local DEARMOR="$(dearmor_filename "$KEYRINGFILE")" get_fingerprints_of_keyring "$DEARMOR" > "$FINGERPRINTS" for KEY in "$@"; do # strip leading 0x, if present: KEY="$(echo "${KEY#0x}" | tr -d ' ')" # check if the key is in this keyring if ! grep -iq "^[0-9A-F]*${KEY}$" "$FINGERPRINTS"; then continue fi if [ ! -w "$KEYRINGFILE" ]; then apt_warn "Key ${KEY} is in keyring ${KEYRINGFILE}, but can't be removed as it is read only." continue fi # check if it is the only key in the keyring and if so remove the keyring altogether if [ '1' = "$(uniq "$FINGERPRINTS" | wc -l)" ]; then mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" # behave like gpg return fi # we can't just modify pointed to files as these might be in /usr or something local REALTARGET if [ -L "$DEARMOR" ]; then REALTARGET="$(readlink -f "$DEARMOR")" mv -f "$DEARMOR" "${DEARMOR}.dpkg-tmp" cp -a "$REALTARGET" "$DEARMOR" fi # delete the key from the keyring aptkey_execute "$GPG_SH" --keyring "$DEARMOR" --batch --delete-keys --yes "$KEY" if [ -n "$REALTARGET" ]; then # the real backup is the old link, not the copy we made mv -f "${DEARMOR}.dpkg-tmp" "${DEARMOR}~" fi if [ "$DEARMOR" != "$KEYRINGFILE" ]; then mv -f "$KEYRINGFILE" "${KEYRINGFILE}~" create_new_keyring "$KEYRINGFILE" aptkey_execute "$GPG_SH" --keyring "$DEARMOR" --armor --export > "$KEYRINGFILE" fi get_fingerprints_of_keyring "$DEARMOR" > "$FINGERPRINTS" done } accessible_file_exists() { if ! test -s "$1"; then return 1 fi if test -r "$1"; then return 0 fi apt_warn "The key(s) in the keyring $1 are ignored as the file is not readable by user '$USER' executing apt-key." return 1 } is_supported_keyring() { # empty files are always supported if ! test -s "$1"; then return 0 fi local FILEEXT="${1##*.}" if [ "$FILEEXT" = 'gpg' ]; then # 0x98, 0x99 and 0xC6 via octal as hex isn't supported by dashs printf if printf '\231' | cmp --silent --bytes=1 - "$1"; then true elif printf '\230' | cmp --silent --bytes=1 - "$1"; then true elif printf '\306' | cmp --silent --bytes=1 - "$1"; then true else apt_warn "The key(s) in the keyring $1 are ignored as the file has an unsupported filetype." return 1 fi elif [ "$FILEEXT" = 'asc' ]; then true #dearmor_filename will deal with them else # most callers ignore unsupported extensions silently apt_warn "The key(s) in the keyring $1 are ignored as the file has an unsupported filename extension." return 1 fi return 0 } foreach_keyring_do() { local ACTION="$1" shift # if a --keyring was given, just work on this one if [ -n "$FORCED_KEYRING" ]; then $ACTION "$FORCED_KEYRING" "$@" else # otherwise all known keyrings are up for inspection if accessible_file_exists "$TRUSTEDFILE" && is_supported_keyring "$TRUSTEDFILE"; then $ACTION "$TRUSTEDFILE" "$@" fi local TRUSTEDPARTS="/etc/apt/trusted.gpg.d" eval "$(apt-config shell TRUSTEDPARTS Dir::Etc::TrustedParts/d)" if [ -d "$TRUSTEDPARTS" ]; then TRUSTEDPARTS="$(readlink -f "$TRUSTEDPARTS")" local TRUSTEDPARTSLIST="$(cd /; find "$TRUSTEDPARTS" -mindepth 1 -maxdepth 1 \( -name '*.gpg' -o -name '*.asc' \))" for trusted in $(echo "$TRUSTEDPARTSLIST" | sort); do if accessible_file_exists "$trusted" && is_supported_keyring "$trusted"; then $ACTION "$trusted" "$@" fi done fi fi } list_keys_in_keyring() { local KEYRINGFILE="$1" shift # fingerprint and co will fail if key isn't in this keyring aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$KEYRINGFILE")" "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2> "${GPGHOMEDIR}/gpgoutput.err" || true if [ ! -s "${GPGHOMEDIR}/gpgoutput.log" ]; then return fi # we fake gpg header here to refer to the real asc file rather than a temp file if [ "${KEYRINGFILE##*.}" = 'asc' ]; then if expr match "$(sed -n '2p' "${GPGHOMEDIR}/gpgoutput.log")" '^-\+$' >/dev/null 2>&1; then echo "$KEYRINGFILE" echo "$KEYRINGFILE" | sed 's#[^-]#-#g' sed '1,2d' "${GPGHOMEDIR}/gpgoutput.log" || true else cat "${GPGHOMEDIR}/gpgoutput.log" fi else cat "${GPGHOMEDIR}/gpgoutput.log" fi if [ -s "${GPGHOMEDIR}/gpgoutput.err" ]; then cat >&2 "${GPGHOMEDIR}/gpgoutput.err" fi } export_key_from_to() { local FROM="$1" local TO="$2" shift 2 if ! aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$FROM")" --export "$@" > "$TO" 2> "${GPGHOMEDIR}/gpgoutput.log"; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false else chmod 0644 -- "$TO" fi } import_keyring_into_keyring() { local FROM="${1:-${GPGHOMEDIR}/pubring.gpg}" local TO="${2:-${GPGHOMEDIR}/pubring.gpg}" shift 2 rm -f "${GPGHOMEDIR}/gpgoutput.log" # the idea is simple: We take keys from one keyring and copy it to another # we do this with so many checks in between to ensure that WE control the # creation, so we know that the (potentially) created $TO keyring is a # simple keyring rather than a keybox as gpg2 would create it which in turn # can't be read by gpgv. # BEWARE: This is designed more in the way to work with the current # callers, than to have a well defined it would be easy to add new callers to. if [ ! -s "$TO" ]; then if [ -s "$FROM" ]; then if [ -z "$2" ]; then local OPTS if [ "${TO##*.}" = 'asc' ]; then OPTS='--armor' fi export_key_from_to "$(dearmor_filename "$FROM")" "$TO" $OPTS ${1:+"$1"} else create_new_keyring "$TO" fi else create_new_keyring "$TO" fi elif [ -s "$FROM" ]; then local EXPORTLIMIT="$1" if [ -n "$1$2" ]; then shift; fi local DEARMORTO="$(dearmor_filename "$TO")" if ! aptkey_execute "$GPG_SH" --keyring "$(dearmor_filename "$FROM")" --export ${EXPORTLIMIT:+"$EXPORTLIMIT"} \ | aptkey_execute "$GPG_SH" --keyring "$DEARMORTO" --batch --import "$@" > "${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi if [ "$DEARMORTO" != "$TO" ]; then export_key_from_to "$DEARMORTO" "${DEARMORTO}.asc" --armor if ! cmp -s "$TO" "${DEARMORTO}.asc" 2>/dev/null; then cp -a "$TO" "${TO}~" mv -f "${DEARMORTO}.asc" "$TO" fi fi fi } dearmor_keyring() { # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=831409#67 # The awk script is more complex through to skip surrounding garbage and # to support multiple keys in one file (old gpgs generate version headers # which get printed with the original and hence result in garbage input for base64 awk '/^-----BEGIN/{ x = 1; } /^$/{ if (x == 1) { x = 2; }; } /^[^=-]/{ if (x == 2) { print $0; }; } /^-----END/{ x = 0; }' | base64 -d } dearmor_filename() { if [ "${1##*.}" = 'asc' ]; then local trusted="${GPGHOMEDIR}/${1##*/}.gpg" if [ -s "$1" ]; then dearmor_keyring < "$1" > "$trusted" fi echo "$trusted" elif [ "${1##*.}" = 'gpg' ]; then echo "$1" elif [ "$(head -n 1 "$1" 2>/dev/null)" = '-----BEGIN PGP PUBLIC KEY BLOCK-----' ]; then local trusted="${GPGHOMEDIR}/${1##*/}.gpg" dearmor_keyring < "$1" > "$trusted" echo "$trusted" else echo "$1" fi } catfile() { cat "$(dearmor_filename "$1")" >> "$2" } merge_all_trusted_keyrings_into_pubring() { # does the same as: # foreach_keyring_do 'import_keys_from_keyring' "${GPGHOMEDIR}/pubring.gpg" # but without using gpg, just cat and find local PUBRING="$(readlink -f "${GPGHOMEDIR}")/pubring.gpg" rm -f "$PUBRING" touch "$PUBRING" foreach_keyring_do 'catfile' "$PUBRING" } import_keys_from_keyring() { import_keyring_into_keyring "$1" "$2" } merge_keys_into_keyrings() { import_keyring_into_keyring "$2" "$1" '' --import-options 'merge-only' } merge_back_changes() { if [ -n "$FORCED_KEYRING" ]; then # if the keyring was forced merge is already done if [ "$FORCED_KEYRING" != "$TRUSTEDFILE" ]; then mv -f "$FORCED_KEYRING" "${FORCED_KEYRING}~" export_key_from_to "$TRUSTEDFILE" "$FORCED_KEYRING" --armor fi return fi if [ -s "${GPGHOMEDIR}/pubring.gpg" ]; then # merge all updated keys foreach_keyring_do 'merge_keys_into_keyrings' "${GPGHOMEDIR}/pubring.gpg" fi # look for keys which were added or removed get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.orig.gpg" > "${GPGHOMEDIR}/pubring.orig.keylst" get_fingerprints_of_keyring "${GPGHOMEDIR}/pubring.gpg" > "${GPGHOMEDIR}/pubring.keylst" comm -3 "${GPGHOMEDIR}/pubring.keylst" "${GPGHOMEDIR}/pubring.orig.keylst" > "${GPGHOMEDIR}/pubring.diff" # key isn't part of new keyring, so remove cut -f 2 "${GPGHOMEDIR}/pubring.diff" | while read key; do if [ -z "$key" ]; then continue; fi foreach_keyring_do 'remove_key_from_keyring' "$key" done # key is only part of new keyring, so we need to import it cut -f 1 "${GPGHOMEDIR}/pubring.diff" | while read key; do if [ -z "$key" ]; then continue; fi import_keyring_into_keyring '' "$TRUSTEDFILE" "$key" done } setup_merged_keyring() { if [ -n "$FORCED_KEYID" ]; then merge_all_trusted_keyrings_into_pubring FORCED_KEYRING="${GPGHOMEDIR}/forcedkeyid.gpg" TRUSTEDFILE="${FORCED_KEYRING}" echo "#!/bin/sh exec sh '($(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" # ignore error as this "just" means we haven't found the forced keyid and the keyring will be empty import_keyring_into_keyring '' "$TRUSTEDFILE" "$FORCED_KEYID" || true elif [ -z "$FORCED_KEYRING" ]; then merge_all_trusted_keyrings_into_pubring if [ -r "${GPGHOMEDIR}/pubring.gpg" ]; then cp -a "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg" else touch "${GPGHOMEDIR}/pubring.gpg" "${GPGHOMEDIR}/pubring.orig.gpg" fi echo "#!/bin/sh exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${GPGHOMEDIR}/pubring.gpg")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" else TRUSTEDFILE="$(dearmor_filename "$FORCED_KEYRING")" create_new_keyring "$TRUSTEDFILE" echo "#!/bin/sh exec sh '$(escape_shell "${GPG}")' --keyring '$(escape_shell "${TRUSTEDFILE}")' \"\$@\"" > "${GPGHOMEDIR}/gpg.1.sh" GPG="${GPGHOMEDIR}/gpg.1.sh" fi } create_new_keyring() { # gpg defaults to mode 0600 for new keyrings. Create one with 0644 instead. if ! [ -e "$1" ]; then if [ -w "$(dirname "$1")" ]; then touch -- "$1" chmod 0644 -- "$1" fi fi } aptkey_execute() { sh "$@"; } usage() { echo "Usage: apt-key [--keyring file] [command] [arguments]" echo echo "Manage apt's list of trusted keys" echo echo " apt-key add <file> - add the key contained in <file> ('-' for stdin)" echo " apt-key del <keyid> - remove the key <keyid>" echo " apt-key export <keyid> - output the key <keyid>" echo " apt-key exportall - output all trusted keys" echo " apt-key update - update keys using the keyring package" echo " apt-key net-update - update keys using the network" echo " apt-key list - list keys" echo " apt-key finger - list fingerprints" echo " apt-key adv - pass advanced options to gpg (download key)" echo echo "If no specific keyring file is given the command applies to all keyring files." } while [ -n "$1" ]; do case "$1" in --keyring) shift if [ -z "$FORCED_KEYRING" -o "$FORCED_KEYRING" = '/dev/null' ]; then TRUSTEDFILE="$1" FORCED_KEYRING="$1" elif [ "$TRUSTEDFILE" = "$FORCED_KEYRING" ]; then create_gpg_home FORCED_KEYRING="${GPGHOMEDIR}/mergedkeyrings.gpg" echo -n '' > "$FORCED_KEYRING" chmod 0644 -- "$FORCED_KEYRING" catfile "$TRUSTEDFILE" "$FORCED_KEYRING" catfile "$1" "$FORCED_KEYRING" else catfile "$1" "$FORCED_KEYRING" fi ;; --keyid) shift if [ -n "$FORCED_KEYID" ]; then apt_error 'Specifying --keyid multiple times is not supported' exit 1 fi FORCED_KEYID="$1" ;; --secret-keyring) shift FORCED_SECRET_KEYRING="$1" ;; --readonly) merge_back_changes() { true; } create_new_keyring() { if [ ! -r "$FORCED_KEYRING" ]; then TRUSTEDFILE='/dev/null'; FORCED_KEYRING="$TRUSTEDFILE"; fi; } ;; --fakeroot) requires_root() { true; } ;; --quiet) aptkey_echo() { true; } ;; --debug1) # some cmds like finger redirect stderr to /dev/null … aptkey_execute() { echo 'EXEC:' "$@"; sh "$@"; } ;; --debug2) # … other more complicated ones pipe gpg into gpg. aptkey_execute() { echo >&2 'EXEC:' "$@"; sh "$@"; } ;; --homedir) # force usage of a specific homedir instead of creating a temporary shift GPGHOMEDIR="$1" ;; --*) echo >&2 "Unknown option: $1" usage exit 1;; *) break;; esac shift done if [ -z "$TRUSTEDFILE" ]; then TRUSTEDFILE="/etc/apt/trusted.gpg" eval $(apt-config shell TRUSTEDFILE Apt::GPGV::TrustedKeyring) eval $(apt-config shell TRUSTEDFILE Dir::Etc::Trusted/f) fi command="$1" if [ -z "$command" ]; then usage exit 1 fi shift prepare_gpg_home() { # crude detection if we are called from a maintainerscript where the # package depends on gnupg or not. We accept recommends here as # well as the script hopefully uses apt-key optionally then like e.g. # debian-archive-keyring for (upgrade) cleanup did if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ] && [ -z "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then if ! dpkg-query --show --showformat '${Pre-Depends}${Depends}${Recommends}\n' "$DPKG_MAINTSCRIPT_PACKAGE" 2>/dev/null | grep -q gnupg; then cat >&2 <<EOF Warning: The $DPKG_MAINTSCRIPT_NAME maintainerscript of the package $DPKG_MAINTSCRIPT_PACKAGE Warning: seems to use apt-key (provided by apt) without depending on gnupg or gnupg2. Warning: This will BREAK in the future and should be fixed by the package maintainer(s). Note: Check first if apt-key functionality is needed at all - it probably isn't! EOF fi fi eval "$(apt-config shell GPG_EXE Apt::Key::gpgcommand)" if [ -n "$GPG_EXE" ] && command_available "$GPG_EXE"; then true elif command_available 'gpg'; then GPG_EXE="gpg" elif command_available 'gpg2'; then GPG_EXE="gpg2" elif command_available 'gpg1'; then GPG_EXE="gpg1" else apt_error 'gnupg, gnupg2 and gnupg1 do not seem to be installed, but one of them is required for this operation' exit 255 fi create_gpg_home # now tell gpg that it shouldn't try to maintain this trustdb file echo "#!/bin/sh exec '$(escape_shell "${GPG_EXE}")' --ignore-time-conflict --no-options --no-default-keyring \\ --homedir '$(escape_shell "${GPGHOMEDIR}")' --no-auto-check-trustdb --trust-model always \"\$@\"" > "${GPGHOMEDIR}/gpg.0.sh" GPG_SH="${GPGHOMEDIR}/gpg.0.sh" GPG="$GPG_SH" # create the trustdb with an (empty) dummy keyring # older gpgs required it, newer gpgs even warn that it isn't needed, # but require it nonetheless for some commands, so we just play safe # here for the foreseeable future and create a dummy one touch "${GPGHOMEDIR}/empty.gpg" if ! "$GPG_EXE" --ignore-time-conflict --no-options --no-default-keyring \ --homedir "$GPGHOMEDIR" --quiet --check-trustdb --keyring "${GPGHOMEDIR}/empty.gpg" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi # We don't usually need a secret keyring, of course, but # for advanced operations, we might really need a secret keyring after all if [ -n "$FORCED_SECRET_KEYRING" ] && [ -r "$FORCED_SECRET_KEYRING" ]; then if ! aptkey_execute "$GPG" -v --batch --import "$FORCED_SECRET_KEYRING" >"${GPGHOMEDIR}/gpgoutput.log" 2>&1; then # already imported keys cause gpg1 to fail for some reason… ignore this error if ! grep -q 'already in secret keyring' "${GPGHOMEDIR}/gpgoutput.log"; then cat >&2 "${GPGHOMEDIR}/gpgoutput.log" false fi fi else # and then, there are older versions of gpg which panic and implode # if there isn't one available - and writeable for imports # and even if not output is littered with the creation of a secring, # so lets call import once to have it create what it wants in silence echo -n | aptkey_execute "$GPG" --batch --import >/dev/null 2>&1 || true fi } warn_on_script_usage() { if [ -n "$APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE" ]; then return fi # (Maintainer) scripts should not be using apt-key if [ -n "$DPKG_MAINTSCRIPT_PACKAGE" ]; then echo >&2 "Warning: apt-key should not be used in scripts (called from $DPKG_MAINTSCRIPT_NAME maintainerscript of the package ${DPKG_MAINTSCRIPT_PACKAGE})" elif [ ! -t 1 ]; then echo >&2 "Warning: apt-key output should not be parsed (stdout is not a terminal)" fi } if [ "$command" != 'help' ] && [ "$command" != 'verify' ]; then prepare_gpg_home fi case "$command" in add) warn_on_script_usage requires_root setup_merged_keyring aptkey_execute "$GPG" --quiet --batch --import "$@" merge_back_changes aptkey_echo "OK" ;; del|rm|remove) # no script warning here as removing 'add' usage needs 'del' for cleanup requires_root foreach_keyring_do 'remove_key_from_keyring' "$@" aptkey_echo "OK" ;; update) warn_on_script_usage requires_root setup_merged_keyring update merge_back_changes ;; net-update) requires_root setup_merged_keyring net_update merge_back_changes ;; list|finger*) warn_on_script_usage foreach_keyring_do 'list_keys_in_keyring' --fingerprint "$@" ;; export|exportall) warn_on_script_usage merge_all_trusted_keyrings_into_pubring aptkey_execute "$GPG_SH" --keyring "${GPGHOMEDIR}/pubring.gpg" --armor --export "$@" ;; adv*) warn_on_script_usage setup_merged_keyring aptkey_echo "Executing: $GPG" "$@" aptkey_execute "$GPG" "$@" merge_back_changes ;; verify) GPGV='' eval $(apt-config shell GPGV Apt::Key::gpgvcommand) if [ -n "$GPGV" ] && command_available "$GPGV"; then true; elif command_available 'gpgv'; then GPGV='gpgv'; elif command_available 'gpgv2'; then GPGV='gpgv2'; elif command_available 'gpgv1'; then GPGV='gpgv1'; else apt_error 'gpgv, gpgv2 or gpgv1 required for verification, but neither seems installed' exit 29 fi # for a forced keyid we need gpg --export, so full wrapping required if [ -n "$FORCED_KEYID" ]; then prepare_gpg_home else create_gpg_home fi setup_merged_keyring if [ -n "$FORCED_KEYRING" ]; then "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "$(dearmor_filename "${FORCED_KEYRING}")" --ignore-time-conflict "$@" else "$GPGV" --homedir "${GPGHOMEDIR}" --keyring "${GPGHOMEDIR}/pubring.gpg" --ignore-time-conflict "$@" fi ;; help) usage ;; *) usage exit 1 ;; esac
Close